import request from '../utils/request.js'


export function userList(param) {
    return request.get('/user/list', {
        params: param
    });
}
export function baseList(param) {
    return request.get('/field/baseList', {
        params: param
    });
}
export function getFieldById(fieldId){
    return request.get('/model/getFieldById?fieldId=' +  fieldId);
}
export function fieldList(param) {
    return request.get('/model/fieldCombineList', {
        params: param
    });
}
export function parseList(param) {
    return request.get('/parse/list', {
        params: param
    });
}
//自动解析状态
export function autoList(param) {
    return request.get('/parse/autoList', {
        params: param
    });
}
export function creditApprovalList(param) {
    return request.get('/parse/creditApprovalList', {
        params: param
    });
}
export function creditReportList() {
    return request.get('/parse/creditReportList');
}

export function partnerList(param) {
    return request.get('/partner/list', {
        params: param
    });
}
export function partnerAdd(param) {
    return request.post('/partner/partnerAdd', param);
}

export function cooperatorList(pageNum,pageSize) {
    return request.post('/cooperator/cooperatorList',{
        pageNum:pageNum,
        pageSize:pageSize,
    });
}

export function selectCooperator(pageNum,pageSize,cooperatorName) {
    return request.post('/cooperator/selectCooperator',{
        pageNum:pageNum,
        pageSize:pageSize,
        cooperatorName:cooperatorName,
    });
}

export function findCooperatorListByName(name) {
    return request.get('/cooperator/findCooperatorListByName?name=' + name);
}

export function findCooperatorFieldByNum(templateId,pageNum,pageSize){
    return request.post('/cooperator/findCooperatorFieldByNum/',{
        templateId:templateId,
        pageNum:pageNum,
        pageSize:pageSize,
      })  ;
}

export function findCooperatorFieldByCooNum(cooperatorNum,pageNum,pageSize){
    return request.post('/cooperator/findCooperatorFieldByCooNum',{
        cooperatorNum:cooperatorNum,
        pageNum:pageNum,
        pageSize:pageSize,
    })  ;
}

export function findCooperatorProductByNum(cooperatorNum,pageNum,pageSize){
    return request.post('/cooperator/findCooperatorProductByNum/',{
        cooperatorNum:cooperatorNum,
        pageNum:pageNum,
        pageSize:pageSize,
    })  ;
}
export function findBaseFieldByNo(templateNo,pageNum,pageSize){
    return request.post('/fieldtemplate/findBaseFieldByNo/',{
        templateNo:templateNo,
        pageNum:pageNum,
        pageSize:pageSize,
    })  ;
}
export function findDeriveFieldByNo(templateNo,pageNum,pageSize){
    return request.post('/fieldtemplate/findDeriveFieldByNo/',{
        templateNo:templateNo,
        pageNum:pageNum,
        pageSize:pageSize,
    })  ;
}

export function fieldTemplateList(pageNum,pageSize) {
    return request.post('/fieldtemplate/findAll',
    {
        pageNum:pageNum,
        pageSize:pageSize,
    });
}
export function selectTemplate(pageNum,pageSize,templateName) {
    return request.post('/fieldtemplate/selectTemplate',
        {
            pageNum:pageNum,
            pageSize:pageSize,
            templateName:templateName,
        });
}
export function fieldTemplateLists() {
    return request.get('/fieldtemplate/fieldTemplateList');

}
export function getTemplateById(templateId){
    return request.get('/fieldtemplate/getTemplateById?id=' +  templateId);
}
export function cooperatorProductList(pageNum,pageSize){
    return request.post('/cooperator_product/cooperatorProductList',
        {
            pageNum:pageNum,
            pageSize:pageSize,
        });
}

export function selectCoopProduct(pageNum,pageSize,productName){
    return request.post('/cooperator_product/selectCoopProduct',
        {
            pageNum:pageNum,
            pageSize:pageSize,
            productName:productName,

        });
}

export function getCooperatorByModel(pageNum,pageSize,modelNo){
    return request.post('/cooperator_product/getCooperatorByModel',
        {
            pageNum:pageNum,
            pageSize:pageSize,
            modelNo:modelNo,
        });
}
export function findCooperatorProductFieldByNum(productNum,pageNum,pageSize){
    return request.post('/cooperator_product/findCooperatorProductFieldByNum',
        {
            productNum:productNum,
            pageNum:pageNum,
            pageSize:pageSize,
        });

}
export function updateProductFieldNo(productNum,fieldNo){
    return request({
        url: '/cooperator_product/updateProductFieldNo/'+ productNum +'/'+ fieldNo,
        method: 'get',
      })  
}
export function findCooperatorFieldsByName(cooperatorName){
    return request({
        url: '/cooperator_product/findCooperatorFieldsByName/'+ cooperatorName ,
        method: 'get',
    })
}
export function getBusinessSize(businessType){
    return request.post('/business/getBusinessSize',
        {
            businessType:businessType
        });
    }
export function businessList(pageNum,pageSize,businessType){
    return request.post('/business/businessList',
        {
            pageNum:pageNum,
            pageSize:pageSize,
            businessType:businessType
        });
    }
export function selectBusiness(pageNum,pageSize,customerName,businessType){
    return request.post('/business/selectBusiness',
        {
            pageNum:pageNum,
            pageSize:pageSize,
            customerName:customerName,
            businessType:businessType

        });
}
export function modelDefineList(){
    return request.get('/model_define/modelDefineList');
}


export function cooperatorProductApply(cooperator_num, cooperator_name,  product_num, product_name, model_id,fieldSelected) {
    return request.post('/cooperator_product/apply', {
        cooperator_num : cooperator_num,
        cooperator_name : cooperator_name, 
        product_num : product_num,
        product_name : product_name,
        model_id : model_id,
        fieldSelected:fieldSelected
    });
}

export function editApply(productId,productNum, productName,  fieldSelectedOld, fieldSelected) {
    return request.post('/cooperator_product/editApply', {
        productId:productId,
        productNum : productNum,
        productName : productName,
        fieldSelectedOld : fieldSelectedOld,
        fieldSelected : fieldSelected,

    });
}

export function findBusinessInfoByNum(businessNum){
    return request({
        url: '/business/findBusinessInfoByNum/'+ businessNum ,
        method: 'get',
    })
}

export function findCustomInfoByHead(headInfId){
    return request({
        url: '/business/findCustomInfoByHead/'+ headInfId ,
        method: 'get',
    })
}
export function simpleDebounce(fn, delay = 100) {
    let timer = null
    return function() {
        let args = arguments
        if (timer) {
            clearTimeout(timer)
        }
        timer = setTimeout(() => {
            fn.apply(this, args)
        }, delay)
    }
}
export function reportFileList(businessNum) {
    return request.get('/report/reportFileList?businessNum=' + businessNum);
}
export function fileDownload(fileName) {
    return request.post('/report/download?fileName=' +fileName);
}

export function downloadMod(fileName) {
    return request.post('/report/downloadMod?fileName=' +fileName);
}

export function reportFileDelete(pageNum,pageSize) {
    return request.post('/report/del', {
        pageNum: pageNum,
        pageSize: pageSize,
    });
}

// export function reportFileDelete(headInfId) {
//     return request.get('/report/del?id=' +id);
// }
export function roleList(name) {
    return request.get('/role/list?name=' + name);
}
export function sysUserInfo(userId) {
    return request.get('/user/info?userId=' + userId);
}

export function userDel(userId) {
    return request.get('/user/del?userId=' + userId);
}

export function userAdd(param) {
    return request.post('/user/add', param);
}

export function userEdit(param) {
    return request.post('/user/edit', param);
}

export function rights() {
    return request.get('/role/rights');
}



export function roleInfo(roleId) {
    return request.get('/role/info?roleId=' + roleId);
}

export function roleDel(roleId) {
    return request.delete('/role/del?roleId=' + roleId);
}

export function roleAdd(param) {
    return request.post('/role/add', param);
}

export function roleEdit(param) {
    return request.post('/role/edit', param);
}

export function userInfo() {
    return request.get('/userInfo');
}


export function fieldInfo(){
    return request.get('/model/getField');
}

export function modelInfo(pageNum,pageSize){
    return request.post('/model/getUserModel',{
        pageNum:pageNum,
        pageSize:pageSize,
    });
}
export function modelSubmit(model_data){
    return request.post('/model/addModel',{
        modeldata:model_data
    })
}
export function approvalInfo(){
    return request.get('/model/getApproval');
}
export function listUser()
{
    return request.get('/model/listUser');
}

export function getFiledByName(username)
{
    return request.post('/model/getFieldByName',{
        username:username
    })
}

export function fieldListNew(pageNum,pageSize)
{
    return request.post('/fieldListNew',
        {
            pageNum:pageNum,
            pageSize:pageSize,
        });
}
export function fieldListBase(pageNum,pageSize)
{
    return request.post('/fieldListBase',        {
        pageNum:pageNum,
        pageSize:pageSize,
    });
}
export function selectFieldListBase(pageNum,pageSize,nameZh)
{
    return request.post('/selectFieldListBase',        {
        pageNum:pageNum,
        pageSize:pageSize,
        nameZh:nameZh,
    });
}
export function fieldListDerive(pageNum,pageSize)
{
    return request.post('/fieldListDerive',        {
        pageNum:pageNum,
        pageSize:pageSize,
    });
}
export function selectFieldListDerive(pageNum,pageSize,nameZh)
{
    return request.post('/selectFieldListDerive',        {
        pageNum:pageNum,
        pageSize:pageSize,
        nameZh:nameZh,
    });
}

export function fieldDel(id) {
    return request.delete('/filed-delete?id=' + id);
}

export function templateDel(id) {
    return request.delete('/fieldtemplate/delete?id=' + id);
}

export function fieldEdit(fieldData) {
    return request.post('/filed-update', {
        id : fieldData.id,
        fieldNo : fieldData.fieldNo,
        nameZh : fieldData.nameZh,
        name : fieldData.name,

        type : fieldData.type,
        fetchLogic : fieldData.fetchLogic,

    });
}

export function fieldTemplateEdit(templateData) {
    return request.post('/fieldtemplate/update', {
        id : templateData.templateId,
        templateNo : templateData.templateNo,
        templateName : templateData.templateName,
        // status : templateData.status,
        fieldBaseSelected:templateData.fieldBaseSelected,
        fieldBaseSelectedOld:templateData.fieldBaseSelectedOld,
        fieldDeriveSelected:templateData.fieldDeriveSelected,
        fieldDeriveSelectedOld:templateData.fieldDeriveSelectedOld,


    });
}
export function fieldTemplateStatus(templateData) {
    return request.post('/fieldtemplate/status', {
        id : templateData.templateId,
        status : templateData.status,


    });
}

export function fieldTemplateSave(templateData) {
    return request.post('/fieldtemplate/save', {
        id : templateData.templateId,
        templateNo : templateData.templateNo,
        templateName : templateData.templateName,
        status : templateData.status,
        fieldSelected:templateData.fieldBaseSelected,
        fieldSelected2:templateData.fieldDeriveSelected,

    });
}

export function cooperatorAdd(cooperator_name, corpCertificateNum, corp_certificate_type, field_template_id) {
    return request.post('/cooperator/add', {
        cooperator_name : cooperator_name,
        corpCertificateNum : corpCertificateNum,
        corp_certificate_type : corp_certificate_type,
        field_template_id : field_template_id
    });
}

export function cooperatorEdit(cooperator_id, cooperator_name, corp_certificate_num, corp_certificate_type,fieldTemplateId) {
    return request.post('/cooperator/edit', {
        cooperator_id : cooperator_id, 
        cooperator_name : cooperator_name,
        corp_certificate_num : corp_certificate_num,
        corp_certificate_type : corp_certificate_type,
        fieldTemplateId:fieldTemplateId
    });
}

export function login(username, password) {
    return request.post('/login', {
        username: username,
        password: password
    })
}


export function randomId() {
    let str = "";
    for (let i = 0; i < 4; i++) {
      str += Math.random()
        .toString()
        .replace(/\./, "");
    }
    str = "uid" + str;
    // 取前32位随机字符，不足补0
    return str.length >= 32
      ? str.substr(0, 32)
      : str + repeat("0", 32 - str.length);
  }